unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, DBCtrls, Grids, DBGrids, ExtCtrls, dataMain,
  Mask, ComCtrls, DB;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    PageControl1: TPageControl;
    tsConnection: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    DBText1: TDBText;
    Label3: TLabel;
    DBText2: TDBText;
    SpeedButton1: TSpeedButton;
    DBEdit1: TDBEdit;
    tsMembers: TTabSheet;
    DBText3: TDBText;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    DBNavigator2: TDBNavigator;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBComboBox1: TDBComboBox;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    tsAttendance: TTabSheet;
    DBGrid2: TDBGrid;
    Panel3: TPanel;
    btnAttendance: TButton;
    DBGrid3: TDBGrid;
    Panel4: TPanel;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    Label11: TLabel;
    Label12: TLabel;
    DBNavigator3: TDBNavigator;
    Label13: TLabel;
    DBText4: TDBText;
    procedure SpeedButton1Click(Sender: TObject);
    procedure btnAttendanceClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then begin
    try
      dtmdlMain.dsClubInfo.Edit;
      dtmdlMain.cdsClubInfo.FieldByName('DATABASE').AsString := OpenDialog1.FileName;
      dtmdlMain.cdsClubInfo.Post;

      dtmdlMain.SQLConnection1.Close;
      dtmdlMain.SQLConnection1.Params.Values['DATABASE'] := dtmdlMain.cdsClubInfo.FieldByName('DATABASE').AsString;
      dtmdlMain.SQLConnection1.Open;
    except
      on e:exception do
        MessageDlg('Unable to establish db connection'+#13+e.message, mtError, [mbOK], 0);
    end;
  end;
end;

procedure TForm1.btnAttendanceClick(Sender: TObject);
begin
  with dtmdlMain do begin
    if cdsMembers.State <> dsBrowse then begin
      MessageDlg('Please save changes to member first', mtInformation, [mbOK], 0);
      Exit;
    end;
    cdsAttendance.Insert;
    cdsAttendance.FieldByName('MEMBER_UID').Value := cdsMembers.FieldByName('UID').Value;
    cdsAttendance.FieldByName('NAME').Value := cdsMembers.FieldByName('NAME').Value;
    cdsAttendance.FieldByName('VISIT_DATE_TIME').AsDateTime := Now;
    cdsAttendance.Post;
    tsAttendance.Show;

    cdsMembers.Edit;
    cdsMembers.FieldByName('LAST_VISIT').AsDateTime := Now;
    cdsMembers.Post;

  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  Self.Caption := 'Club code '+dtmdlMain.cdsClubInfo.FieldByName('CLUB_CODE').AsString;
end;

end.
